package net.jnjmx.ch11;

import java.net.URL;
import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.ObjectName;
import javax.management.ObjectInstance;
import java.util.ArrayList;
/**
 * @author - Heather Kreger
 * Java and JMX: Building Manageable Systems, Chapter 11
 * 
 * The program is provided "as is" without any warranty express or implied,
 * including the warranty of non-infringement and the implied warranties of
 * merchantibility and fitness for a particular purpose. The author will not be
 * liable for any damages suffered by you or any third party claim against 
 * you regarding the Program.
 */
/** 
 * Standard MBean implemenation to manage a StockQuote service. This MBean
 * configures and sets the stock exchange for the service.
 */
public class StockQuoteManager implements StockQuoteManagerMBean {
    URL exchange, backupExchange, newbkup;
    ObjectName sqName;

	/** 
	 * see StockQuoteManagerMBean
	 * Constructor registers itself with an MBeanServer
	 * */
	public StockQuoteManager () {
	  try {
		sqName = new ObjectName("WebServiceManager:id=StockQuoteManager");
		MBeanServer sqMBS = (MBeanServer)((ArrayList)MBeanServerFactory.findMBeanServer(null)).get(0);
		StockQuoteManager sqMBean = new StockQuoteManager();
		ObjectInstance oi = sqMBS.registerMBean(sqMBean, sqName);
	  } catch (Exception e) {
	  	System.out.println("StockQuoteManager: Could not create MBean");
	  }
	}

	/**
	 * see StockQuoteManagerMBean
	 * */
    public URL getStockExchange () { 
    	return exchange;
    }
    
    /**
	 * see StockQuoteManagerMBean
	 * */
    public void setStockExchange (URL newEexchange) {
        exchange = newEexchange; 
    }
    
    /**
	 * see StockQuoteManagerMBean
	 * */
    public void setBackUpStockExchange (URL newEexchange) {
        backupExchange = newEexchange; 
    }
    
    /**
	 * see StockQuoteManagerMBean
	 * */
    public URL getBackUpStockExchange () {
        return  backupExchange; 
    }

	/**
	 * see StockQuoteManagerMBean
	 * */
    public void switchStockExchange () {
        newbkup = exchange;
    	exchange = backupExchange;
    	backupExchange = newbkup;
    }
}
