package net.jnjmx.ch11;

/**
 * @author - Heather Kreger
 * Java and JMX: Building Manageable Systems, Chapter 11
 * 
 * The program is provided "as is" without any warranty express or implied,
 * including the warranty of non-infringement and the implied warranties of
 * merchantibility and fitness for a particular purpose. The author will not be
 * liable for any damages suffered by you or any third party claim against 
 * you regarding the Program.
 */
/**
 * Standard MBean interface to manage a UDDI Registry as the owner of the 
 * registry. It supports  attributes, and operations.
 * */
public interface UDDIRegistryManagerMBean {
	// identity
	/** * see UDDIRegistryClientManagerMBean	 * */
	String getName();
	/** * see UDDIRegistryClientManagerMBean	 * */
	void setName(String name);
	/** * see UDDIRegistryClientManagerMBean	 * */
	String getVersion();
	
	// config
	/** * see UDDIRegistryClientManagerMBean	 * */
	String getURL();
	/** * see UDDIRegistryClientManagerMBean	 * */
	void setURL(String url);
	/** * see UDDIRegistryClientManagerMBean	 * */
	String[] getURLs();
	/** * see UDDIRegistryClientManagerMBean	 * */
	void setURLs(String[] secureURLs);
	/** * see UDDIRegistryClientManagerMBean	 * */
	String getStatus();
	
	// metrics
	/** * see UDDIRegistryData	 * */
	int getNumberOfEntries();
	/** * see UDDIRegistryData	 * */
	int getNumberOfGets();
	/** * see UDDIRegistryData	 * */
	int getNumberOfSearchs();
	/** * see UDDIRegistryData	 * */
	int getAverageSearchTime();
	/** * see UDDIRegistryData	 * */
	int getAverageGetTime();
	/** * see UDDIRegistryData	 * */
	int getHighSearchTime();
	/** * see UDDIRegistryData	 * */
	int getHighGetTime();
	/** * see UDDIRegistryData	 * */
	int getLowSearchTime();
	/** * see UDDIRegistryData	 * */
	int getLowGetTime();
	
	// operations
	/** * see UDDIRegistryController	 * */
	int start();
	/** * see UDDIRegistryController	 * */
	int stop();
	/** * see UDDIRegistryController	 * */
	int backUpRegistryData();
}
