package net.jnjmx.ch4;
import java.io.InputStream;
import java.io.FileInputStream;
import java.net.URL;

import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.ObjectName;
import javax.management.modelmbean.ModelMBean;

import org.apache.commons.modeler.ManagedBean;
import org.apache.commons.modeler.Registry;

public class ApacheHKManager { 

	public static void main(String[] args) {
		System.out.println("Create configuration registry ...");
		
		try {

			MBeanServer mbs = MBeanServerFactory.createMBeanServer();
			
			Apache mr =
				new Apache("http://www.apache.org/server-status?auto");
			
			ObjectName asmname = new ObjectName("apacheManager:id=ApacheServer1");
			
			XMLService xs = new XMLService();
			ModelMBean mmb = (ModelMBean) xs.createMBeanFromXMLFile("net/jnjmx/ch4/apachesamp2.xml", asmname, mr);
			
			mbs.registerMBean(mmb, asmname);
			
			// this part would probably happen from another object, not within the same program...
			
			String currState = (String) mbs.invoke(asmname, "getState",  new Object[] {}, new String[] {});
			System.out.println("state is " + currState);
			float cpuload =
				((Float) mbs
					.getAttribute(
						asmname,
						"CpuLoad")).floatValue();
			int busyworkers = ((Integer) mbs.getAttribute(asmname, "BusyWorkers")).intValue();
			int totalaccesses = ((Integer) mbs.getAttribute(asmname, "TotalAccesses")).intValue();
			System.out.println(cpuload);
			System.out.println(busyworkers);
			System.out.println(totalaccesses);
		} catch (Throwable t) {
			t.printStackTrace(System.out);
			System.exit(1);
		}
	}
}
