package net.jnjmx.ch4;

import javax.management.*;
import javax.management.modelmbean.*;

import java.lang.reflect.Constructor;
import java.util.ArrayList;

// Uses ModelMBean to manage an instance of the Apache class
// XML Primed ModelMBeanInfo
// Writes itself to an apachesamp1.XML file

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ApacheServerManagerXML {

	public static void main(String[] args) {
		boolean tracing = false;
		String serverURL = "";
		try {
	
			 if  (args.length != 0) {
			 	System.out.println(args[0]);
			 	if (args[0] != null)
			 		 serverURL = serverURL.concat(args[0]);
			 	else 
			 		serverURL = "http://www.apache.org/server-status?auto"; 
			 	
				if ( (args[1] != null)  && (args[1]).equalsIgnoreCase("trace") ) 
			  		tracing = true;
			 }
			 
			XMLService XMLPrimer = new XMLService();
			 
			if (!serverURL.startsWith("http")) 
				serverURL = "http://www.apache.org/server-status?auto";
			
			if (tracing) System.out.println("Running Apache Server Manager for " + serverURL);
		
			/** Find an MBeanServer for our MBean */
			MBeanServer myMBS = MBeanServerFactory.createMBeanServer();
		    if (tracing) System.out.println("created MBeanServer");
			

			
			/** Create a name for the MBean */
			ObjectName apacheMBeanName = new ObjectName("apacheManager: id=ApacheServer1");
			
			/** instantiate the ApacheServer utility to be delegated to */
			ApacheServer myApacheServer = new ApacheServer(serverURL);
			if (tracing) System.out.println("Created apache server");
			
			/** Instantiate an unconfigured RequiredModelMBean in the MBeanServer */
			ModelMBean apacheMMBean = (ModelMBean) XMLPrimer.createMBeanFromXMLFile("net/jnjmx/ch4/apachesamp3.xml", 
													"ApacheServer",
													myApacheServer); 
			if (tracing) System.out.println("created ModelMBean from XML file ");
		
			// ** register the ModelMBean that is now ready to run with the MBeanServer
			ObjectInstance registeredApacheMMBean = myMBS.registerMBean(apacheMMBean, apacheMBeanName);

			// ** Use the ModelMBean to send the notification into JMX where it gets sent to a manager 
			// adapter that is registered for notifications from the Apache MBeans and sends them to a pager system
			
			String apacheStatus = (String) apacheMMBean.invoke("getState",null, null);
			if (tracing) System.out.println("Apache Manager returned " + apacheStatus);
			
			if ( (apacheStatus.equals("DOWN") ) || (apacheStatus.equals("NOT_RESPONDING") ) ) {
			//if ( apacheStatus.equalsIgnoreCase("DOWN") ) {
				if (tracing) System.out.println("Apache Server is Down");
				apacheMMBean.sendNotification("Apache Server is Down");
				/* create monitor to notify when up again so web traffic can be routed back to it */
			}
			else 
				if (tracing) System.out.println("Apache Server is " + apacheStatus);
							
			/** create a String monitoring Mbean to monitor the apache servers status on a periodic basis */
		  	/** Ward help here */
		} catch (Exception e) {
			System.out.println("Apache Server Manager failed with " + e.getMessage());
		}
		System.exit(0);
	}
}
