package net.jnjmx.ch4;
import java.io.InputStream;
import java.io.FileInputStream;
import java.net.URL;

import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.ObjectName;
import javax.management.modelmbean.ModelMBean;

import org.apache.commons.modeler.ManagedBean;
import org.apache.commons.modeler.Registry;

public class ApacheStatusManager {

	public static void main(String[] args) {
		System.out.println("Create configuration registry ...");
		
		try {
//			Class myclass = Class.forName("net.jnjmx.ch4.ApacheStatusManager");
//			URL url = myclass.getResource("/mbeans-descriptors.xml");
//			URL url =
//				ApacheManager.class.getResource(
//					"/mbeans-descriptors.xml");
//			InputStream stream = url.openStream();

			InputStream stream = new FileInputStream("net/jnjmx/ch4/apachembeanDescriptor.xml");
			Registry.loadRegistry(stream);
			stream.close();
			Registry registry = Registry.getRegistry();
			ManagedBean mb = registry.findManagedBean("Apache");
			Apache ms =
				new Apache("http://www.apache.org/server-status?auto");
			ModelMBean mmb = mb.createMBean(ms);
			MBeanServer mbs = MBeanServerFactory.createMBeanServer();
			ObjectName asmname = new ObjectName("monitors:id=ApacheStatus");
			mbs.registerMBean(mmb, asmname);
			float cpuload =
				((Float) mbs
					.getAttribute(
						asmname,
						"CpuLoad"))
					.floatValue();
			int busyworkers = ((Integer) mbs.getAttribute(asmname, "BusyWorkers")).intValue();
			long totalaccesses = ((Integer) mbs.getAttribute(asmname, "TotalAccesses")).intValue();
			System.out.println(cpuload);
			System.out.println(busyworkers);
			System.out.println(totalaccesses);
		} catch (Throwable t) {
			t.printStackTrace(System.out);
			System.exit(1);
		}
	}
}
