package net.jnjmx.ch4;

import java.util.HashSet;
import java.util.Set;
 
public class SessionPool2  {
	private static final int POOLSIZE = 8;

	private Set sessions;
	private int size;

	public SessionPool2() {
		this(POOLSIZE);
	}

	public SessionPool2(int size) {
		this.size = size;
		sessions = new HashSet(this.size);
		fill();
	}
	
	public synchronized void grow(int increment) {
		for (int i = 0; i < increment; i++) {
			Session2 s = new Session2(this);
			sessions.add(s);
		}
		size = size + increment;
	}
	
	public Integer getSize() {
		return new Integer(size);
	}
	
	public synchronized Integer getAvailableSessions() {
		return new Integer(sessions.size());
	}

	public synchronized void release(Session2 session) {
		sessions.add(session);
		notify();
	}

	public synchronized Session2 reserve() {
		while (sessions.isEmpty()) {
			try {
				wait();
			} catch (InterruptedException x) {
				// see if the set is still empty
			}
		}
		Session2 s = (Session2) sessions.iterator().next();
		sessions.remove(s);
		return s;
	}

	private void fill() {
		for (int i = 0; i < size; i++) {
			Session2 s = new Session2(this);
			sessions.add(s);
		}
	}
}