package net.jnjmx.ch4;

import javax.management.*;
import javax.management.modelmbean.*;

/* import javax.management.AttributeList;
import javax.management.AttributeNotFoundException;
import javax.management.MBeanException;
import javax.management.ReflectionException;
import javax.management.RuntimeOperationsException;
import javax.management.modelmbean.ModelMBeanInfo;
import javax.management.modelmbean.RequiredModelMBean;
import javax.management.InstanceNotFoundException;
import javax.management.Descriptor;
*/

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class XMLModelMBean extends RequiredModelMBean {

	/**
	 * Constructor for XMLModelMBean.
	 * @throws MBeanException
	 * @throws RuntimeOperationsException
	 */
	public XMLModelMBean() throws MBeanException, RuntimeOperationsException {
		super();
//		try {
//			load();
//		} catch (Exception e) {
//			// didn't find the file with primer data, thats ok
//		}
	}
	
	public XMLModelMBean(String filename, String mbeanName) throws MBeanException, RuntimeOperationsException {
		super();
		try {
			load(filename, mbeanName);
		} catch (Exception e) {
			// didn't find the file with primer data, thats ok
		}
	}
		

	/**
	 * Constructor for XMLModelMBean.
	 * @param arg0
	 * @throws MBeanException
	 * @throws RuntimeOperationsException
	 */
	public XMLModelMBean(ModelMBeanInfo arg0)
		throws MBeanException, RuntimeOperationsException {
		super(arg0);
		try {
			load();
		} catch (Exception e) {
			// didn't find the file with primer data, thats ok
		}
	}

	/**
	 * @see javax.management.DynamicMBean#getAttribute(String)
	 */
	public Object getAttribute(String arg0)
		throws AttributeNotFoundException, MBeanException, ReflectionException {
		return super.getAttribute(arg0);
	}

	/**
	 * @see javax.management.DynamicMBean#getAttributes(String[])
	 */
	public AttributeList getAttributes(String[] arg0) {
		return super.getAttributes(arg0);
	}

	/**
	 * @see javax.management.DynamicMBean#invoke(String, Object[], String[])
	 */
	public Object invoke(String arg0, Object[] arg1, String[] arg2)
		throws MBeanException, ReflectionException {
		return super.invoke(arg0, arg1, arg2);
	}

	/**
	 * @see javax.management.DynamicMBean#setAttributes(AttributeList)
	 */
	public AttributeList setAttributes(AttributeList arg0) {
		return super.setAttributes(arg0);
	}

	/**
	 * This version of load expects a file name and mbean name in the file in the format required
	 * by the jakarta modeler.
	 */	
	public void load(String filename, String name) 
		throws MBeanException, RuntimeOperationsException, InstanceNotFoundException
	{
		try
		{ // look for file of that name
			XMLService XMLPrimer = new XMLService();
			ModelMBeanInfo newInfo = (ModelMBeanInfo) XMLPrimer.createMBeanInfoFromXMLFile(filename, name);
			setModelMBeanInfo(newInfo);
		} catch (Exception e)
		{
			System.out.println("load(): Persistent MBean XML file was not found");
		} 
	}

	public void load()
	throws MBeanException, RuntimeOperationsException, InstanceNotFoundException
	{
		Descriptor mmbDesc = ((ModelMBeanInfo) getMBeanInfo()).getMBeanDescriptor();

		// we will use the persistLocation to be the directory for the XML file
		// we will use the persistName to be the file to save the XML data for the MBean to
		String persistDir = (String) mmbDesc.getFieldValue("persistLocation");
		String persistFile = (String) mmbDesc.getFieldValue("persistName");

		String currName = (String) mmbDesc.getFieldValue("name");

		if ((persistDir == null) || (persistFile == null))
		{	// Persistence not supported for this MBean, return without error
			return;
		}
		
		String loadTarget = persistDir.concat("/" + persistFile);
		load(loadTarget, currName);
	}

public void store()
	throws MBeanException, RuntimeOperationsException, InstanceNotFoundException
	{
		/* Store in database with record name = mbean name in database */
		/* persist attributes:
		   persist if persistPolicy != never ||
		   persistPolicy == always ||
		   persistPolicy == onTimer && now > lastPersistTime + persistPeriod ||
		   persistPolicy == NoMoreOftenThan && now > lastPersistTime + persistPeriod
		   don't persist if persistPolicy == never ||
		   persistPolicy == onUpdate ||
		   persistPolicy = onTimer && now < lastPersistTime + persistPeriod
		*/

		/* set lastPersistTime on attribute */
		/* persist ModelMBeanInfo */
		/* persist descriptors */

		/* check to see if should be persisted */
		boolean MBeanPersistItNow = true;
		if (getMBeanInfo() == null)
		{
			throw new RuntimeOperationsException(new 
				IllegalArgumentException("ModelMBeanInfo must not be null"), 
				("Exception occured trying to set the store data for the RequiredModelMBean"));
		}
		Descriptor mmbDesc = ((ModelMBeanInfo) getMBeanInfo()).getMBeanDescriptor();

		// Boolean MBeanPersistItNow = this.persistItNow(mmbDesc);
		if (MBeanPersistItNow == true)
		{
			try
			{
				// get directory
				String persistDir =  (String) mmbDesc.getFieldValue("persistLocation");
				String persistFile =  (String) mmbDesc.getFieldValue("persistName");
				
				String persistTarget = "net/jnjmx/ch4/storeout.xml";  // just for testing.... 
				
				//String currName = (String) mmbDesc.getFieldValue("name");
				//if ((persistDir == null) || (persistFile == null))
				//{	// Persistence not supported for this MBean, no error
				//	return;
				//}
				//String persistTarget = persistDir.concat("/" + persistFile);
				// Call another method in this app to write MBeanInfo as a database record
				XMLService XMLPrimer = new XMLService();
				XMLPrimer.writeXMLFile(this, persistTarget);
			} catch (Exception e)
			{
				System.out.println("store(): Exception storing MBean into file for RequiredModelMBean " + e.getClass() + ":" + e.getMessage());
				e.printStackTrace();
			}
		}

}

}
