package net.jnjmx.ch4;

import java.lang.reflect.Constructor;
import javax.management.*;
import javax.management.modelmbean.*;
import net.jnjmx.ch4.XMLService.*;

import java.io.*;

import org.apache.commons.modeler.ManagedBean;
import org.apache.commons.modeler.Registry;

/*
 * Modify to use the Apache modler like this example from ApacheStatusManager
 * 		try {
			URL url =
				ApacheStatusManager.class.getResource(
					"/mbeans-descriptors.xml");
			InputStream stream = url.openStream();
			Registry.loadRegistry(stream);
			stream.close();
			Registry registry = Registry.getRegistry();
			ManagedBean mb = registry.findManagedBean("ModStatus");
			ModStatus ms =
				new ModStatus("http://www.apache.org/server-status?auto");
			ModelMBean mmb = mb.createMBean(ms);
			MBeanServer mbs = MBeanServerFactory.createMBeanServer();
			ObjectName asmname = new ObjectName("monitors:id=ApacheStatus");
			mbs.registerMBean(mmb, asmname);
			float cpuload =
				((Float) mbs
					.getAttribute(
						asmname,
						"CpuLoad"))
					.floatValue();
			int busyworkers = ((Integer) mbs.getAttribute(asmname, "BusyWorkers")).intValue();
			long totalaccesses = ((Integer) mbs.getAttribute(asmname, "TotalAccesses")).intValue();
			System.out.println(cpuload);
			System.out.println(busyworkers);
			System.out.println(totalaccesses);
		} catch (Throwable t) {
			t.printStackTrace(System.out);
			System.exit(1);
		}
 * 
 * */

public class XMLService implements XMLServiceMBean {
	
	static boolean tracing = true; 
	private ObjectName myObjectName = null;

	//public XMLService() throws Exception {
	public XMLService(ObjectName svcName) throws Exception {
		
  		myObjectName = svcName;
 //     ObjectInstance registeredXMLService = mbs.registerMBean((Object) this, svcName);
		if (tracing) System.out.println("created XMLService MBean");
		
	}
	public XMLService() throws Exception {
	}

	
	public Object createMBeanFromXMLFile(String fileName, ObjectName mbName, Object managedResource) {
		ModelMBean xmlMBean = null;
		try {
			String name = mbName.toString().substring((mbName.toString()).indexOf(':')+1);
			xmlMBean = createMMBean(fileName, name, managedResource);
			System.out.println("Created MBean from file " + fileName);
		}
		catch (Exception e) {
			System.out.println("XMLService.createMBean failed");
		}
		return xmlMBean;
	}
	
	public Object createMBeanFromXMLFile(String fileName, String mbName, Object managedResource) {
		ModelMBean xmlMBean = null; 
		try {
			xmlMBean = createMMBean(fileName, mbName, managedResource);
			System.out.println("Created MBean from file " + fileName);
		}
		catch (Exception e) {
			System.out.println("XMLService.createMBean failed");
		}
		return xmlMBean;
	}
	
	public Object createMBeanFromXMLFile(String fileName, ObjectName mbName) {
		ModelMBean xmlMBean = null;
		try {
			String name = mbName.toString().substring((mbName.toString()).indexOf(':')+1);
			xmlMBean = createMMBean(fileName, name, null);
			System.out.println("Created MBean from file " + fileName);
		}
		catch (Exception e) {
			System.out.println("XMLService.createMBean failed");
		}
		return xmlMBean;
	}
	
	public Object createMBeanFromXMLFile(String fileName, String mbName) {
		ModelMBean xmlMBean = null;
		try {
			xmlMBean = createMMBean(fileName, mbName, null);
			System.out.println("Created MBean from file " + fileName);
		}
		catch (Exception e) {
			System.out.println("XMLService.createMBean failed");
		}
		return xmlMBean;
	}
	
	public MBeanInfo createMBeanInfoFromXMLFile(String fileName, String name, Object mr) {
		try {
			System.out.println("XMLService reading from file " + fileName);
			ModelMBean xmlMBean = createMMBean(fileName, name, mr);
			MBeanInfo mbi = xmlMBean.getMBeanInfo();
			return mbi;
		} catch (Exception e) {
			System.out.println("XMLService: unable to return MBeanInfo, exception " + e.getMessage());
			return null;
		}
	}
	
	public MBeanInfo createMBeanInfoFromXMLFile(String fileName, String name) {
		try {
			System.out.println("XMLService reading from file " + fileName);
			
			ModelMBean xmlMBean = createMMBean(fileName, name, null);
			MBeanInfo mbi = xmlMBean.getMBeanInfo();
			return mbi;
		} catch (Exception e) {
			System.out.println("XMLService: unable to return MBeanInfo, exception " + e.getMessage());
			return null;
		}
	}
	
		
	public ModelMBean createMMBean(String filename, String mbName, Object managedResource) {
		ModelMBean mmb = null;
		if (filename.equals("")) filename = "net/jnjmx/ch4/mbeans-descriptors.xml";
		if (mbName.equals("")) mbName = "Apache";
		
		try {
			InputStream stream = new 
				FileInputStream(filename);
			Registry.loadRegistry(stream);
			stream.close();
			Registry registry = Registry.getRegistry();
			ManagedBean mb = registry.findManagedBean(mbName);
			// associate the mbean instance if there is one
			if (managedResource == null)
				mmb = mb.createMBean();
			else
				mmb = mb.createMBean(managedResource);
		} catch (FileNotFoundException feb) {
			System.out.println("XMLService: XML MBean file " + filename + " not found.");
			return null;
		}
		catch (Exception e) {
			System.out.println("XMLService: Unable to create ModelMBean, exception: " + e.getMessage());
		}
		return mmb;
	}	
	
	File outfile;
	FileOutputStream out;
	
	public void writeXMLFile( ModelMBean inMB, String fileName) {
		System.out.println("XMLService writing to " + fileName);
		ModelMBeanInfo info = (ModelMBeanInfo) inMB.getMBeanInfo();
	  try {
		/* open output file */
		out = new FileOutputStream(fileName);
		String fv;
		
		// write header
		echox("<?xml version=\"1.0\"?>");
		echox("<!DOCTYPE mbeans-descriptors PUBLIC");
 		echox("     \"-//Apache Software Foundation//DTD Model MBeans Configuration File\"");
 		echox("     \"http://jakarta.apache.org/commons/dtds/mbeans-descriptors.dtd\"> ");

		// write mbean id
		echox("<mbeans-descriptors>");
		echox("<mbean ");
		Descriptor mbdesc = info.getMBeanDescriptor();
		if (mbdesc != null) {
	  		if ( (fv = (String) mbdesc.getFieldValue("name")) != null ) echox("     name=\"" + fv + "\"");
	        if ( (fv = (String) mbdesc.getFieldValue("type")) != null ) echox("     type=\"" + fv + "\"");
	        if ( (fv = (String) mbdesc.getFieldValue("domain")) != null ) echox("     domain=\"" + fv + "\"");
	        if ( (fv = (String) mbdesc.getFieldValue("group")) != null ) echox("     group=\"" + fv + "\"");
		}
  		echox("     className=\"" + info.getClassName() + "\"");
        echox("     description=\"" + info.getDescription() + "\"");

        echox("     > ");

		
		// write attributes:
		/* <attribute   name="BusyWorkers"
                 description="The number of worker processes busy handling requests"
                 type="int"
                 writeable="false">
      			 <descriptor>
       			 	<field name="highThreshold" value="256"/>
      			 </descriptor>
    		</attribute> */
    	
    	MBeanAttributeInfo[] attrInfo = info.getAttributes();
		if ((attrInfo != null) && (attrInfo.length>0))
		{
			for (int i=0; i<attrInfo.length; i++)
			{
				echox("<attribute");
				echox("     name=\"" + attrInfo[i].getName() + "\"");
				echox("     description=\"" + attrInfo[i].getDescription() + "\"");
				echox("     type=\"" + attrInfo[i].getType() + "\"");
				echox("     readable=\"" + attrInfo[i].isReadable() + "\"");
				echox("     writeable=\"" + attrInfo[i].isWritable() + "\"");
				echox("     is=\"" + attrInfo[i].isIs() + "\"");
				mbdesc = ((ModelMBeanAttributeInfo)attrInfo[i]).getDescriptor();
				if ( (fv = (String) mbdesc.getFieldValue("getMethod")) != null )
					echox("     getMethod=\"" + fv + "\"");
				if ( (fv = (String) mbdesc.getFieldValue("setMethod")) != null )
					echox("     setMethod=\"" + fv + "\"");
				if ( (fv = (String) mbdesc.getFieldValue("displayName")) != null )
					echox("     displayName=\"" + fv + "\"");
				echox("     > ");
				writeDescriptor(((ModelMBeanAttributeInfo)attrInfo[i]).getDescriptor());
				echox("</attribute>");
			}
		} 
		
		// Constructors
		MBeanConstructorInfo[] constrInfo = info.getConstructors();
		if ((constrInfo != null) && (constrInfo.length>0)) {
		for (int i=0; i<constrInfo.length; i++)
		{
			echox("<constructor");
			echox("     name=\""+ constrInfo[i].getName() + "\"");
			if ( (fv = (String) (((ModelMBeanConstructorInfo)constrInfo[i]).getDescriptor()).getFieldValue("getMethod")) != null )
				echox("     displayName=\"" + ((ModelMBeanConstructorInfo)constrInfo[i]).getDescriptor().getFieldValue("displayName") + "\"");
			echox("     > ");
			writeParameters(constrInfo[i].getSignature() );
			writeDescriptor(((ModelMBeanConstructorInfo)constrInfo[i]).getDescriptor());
			echox("</constructor>");
		} 
		}
		
		// Notifications
		MBeanNotificationInfo[] notifInfo = info.getNotifications();
		if ((notifInfo != null) && (notifInfo.length>0))
		{
			for (int i=0; i<notifInfo.length; i++)
			{
				echox("<notification");
				echox("     name=\"" + notifInfo[i].getName() + "\"");
				echox("     description=\"" + notifInfo[i].getDescription() + "\"");
				echox("     > ");
				writeNotificationTypes(notifInfo[i].getNotifTypes());
				writeDescriptor(((ModelMBeanNotificationInfo) notifInfo[i]).getDescriptor());
				echox("</notification>");
			}
		}
		
		// Operations
		MBeanOperationInfo[] opInfo = info.getOperations();
		if ((opInfo != null) && (opInfo.length>0))
		{
			for (int i=0; i<opInfo.length; i++)
			{
				echox("<operation");   
				echox("     name=\"" + opInfo[i].getName() + "\"");
				echox("     description=\"" + opInfo[i].getDescription() + "\"");
				echox("     returnType=\"" + opInfo[i].getReturnType() + "\"");
				echox("     impact=\"" + opInfo[i].getImpact() + "\"");
				echox("     > ");
				writeParameters(opInfo[i].getSignature());
				writeDescriptor(((ModelMBeanOperationInfo)opInfo[i]).getDescriptor());
				echox("</operation>");
			}
		}
				
		writeDescriptor(info.getMBeanDescriptor());
		
		echox("</mbean>");
		echox("</mbeans-descriptors>");
		
		// all done
		out.flush();
		out.close();
	  } catch (NullPointerException ne) {
	  	// if some of the values are not in the descriptor, its ok, just don't write that line
	  } catch (IOException ie) {
	  	System.out.println("XMLService: Writing MBean failed with IO exception");
	  } catch (Exception e) {
	  	System.out.println("XMLService: Exception writing MBean, " + e.getMessage() );
	  }
	  
	}
	
	public void writeDescriptor(Descriptor dsc) {
		//  <descriptor>
        //			<field name="highThreshold" value="256"/>
        //	</descriptor>
        if (dsc == null) return;
        try {
			// String[] fieldNames = dsc.getFieldNames();
			// Object[] fieldValues = dsc.getFieldValues(null);
			// if ((fieldNames == null) || (fieldNames.length == 0)) return;
			// if ((fieldValues == null) || (fieldValues.length == 0)) return;
			String[] fields = dsc.getFields();
			if ((fields == null) || (fields.length == 0)) return;
			echox("     <descriptor>");
			int i=0;
			String name, value;
			for (i=0; i < fields.length; i++) {
				name = fields[i].substring(0, (fields[i].indexOf('=')));
				value = fields[i].substring((fields[i].indexOf('=')) + 1);
				value = value.replace('(', ' ');
				value = value.replace(')', ' ');
				value = value.trim();
				echox("		     <field name=\"" + name + 
					  "\" value=\"" + value + "\"/>");
			}
			echox("     </descriptor>");
        } catch (NullPointerException ne) {
        	// if we get this, just keep going
        }
	}
	
	public void writeParameters(MBeanParameterInfo[] parms) {
		if ((parms == null) || (parms.length == 0)) return;
		int i=0;
		String pName, pDesc;
		for (i=0; i < parms.length; i++) {
			pName = parms[i].getName();
			if ((pName == null) || (pName.equals(""))) pName = ("arg" + i);
			pDesc = parms[i].getDescription();
			if ((pDesc == null) || (pDesc.equals(""))) pDesc = "argument";
			echox("     <parameter name=\"" + parms[i].getName() + 
						"\" description=\"" + parms[i].getDescription() + 
						"\" type=\"" + parms[i].getType() + "\"/>");
		}
	}
	
	public void writeNotificationTypes(String[] types) {
		if ((types == null) || (types.length == 0)) return;
		int i=0;
		echox("<notification-type>");
		for (i=0; i < types.length; i++) {
			echox(types[i]);
		}
		echox("</notification-type>");
	}
	
	public void echox(String str) {
		if (str == null) return;
		str = str.concat(" \n");
		try {
			byte[] strInBytes = str.getBytes();
			out.write(strInBytes);
		} catch (Exception e) {
			System.out.println("Filewriter failed with " + e.getMessage());
		}
	}
	
	public void echos(String str) {
		if (str == null) return;
		System.out.println(str);
	}
	
	public void printMBeanInfo(ModelMBean inMB) {
		
		ModelMBeanInfo info = (ModelMBeanInfo) inMB.getMBeanInfo();
		echos("\nCLASSNAME: \t"+ info.getClassName());
		echos("\nDESCRIPTION: \t"+ info.getDescription());
		echos("\nATTRIBUTES");
		MBeanAttributeInfo[] attrInfo = info.getAttributes();
		if (attrInfo.length>0)
		{
			for (int i=0; i<attrInfo.length; i++)
			{
				echos(" ** NAME: \t"+ attrInfo[i].getName());
				echos("    DESCR: \t"+ attrInfo[i].getDescription());
				echos("    TYPE: \t"+ attrInfo[i].getType() +
					 "\tREAD: "+ attrInfo[i].isReadable() +
					 "\tWRITE: "+ attrInfo[i].isWritable());
				echos("    DESCRIPTOR: \t" + (((ModelMBeanAttributeInfo)attrInfo[i]).getDescriptor()).toString());
			}
		} else echos(" ** No attributes **");
		echos("\nCONSTRUCTORS");
		MBeanConstructorInfo[] constrInfo = info.getConstructors();
		for (int i=0; i<constrInfo.length; i++)
		{
			echos(" ** NAME: \t"+ constrInfo[i].getName());
			echos("    DESCR: \t"+ constrInfo[i].getDescription());
			echos("    PARAM: \t"+ constrInfo[i].getSignature().length +" parameter(s)");
			echos("    DESCRIPTOR: \t" + (((ModelMBeanConstructorInfo)constrInfo[i]).getDescriptor()).toString());
		}
		echos("\nOPERATIONS");
		MBeanOperationInfo[] opInfo = info.getOperations();
		if (opInfo.length>0)
		{
			for (int i=0; i<opInfo.length; i++)
			{
				echos(" ** NAME: \t"+ opInfo[i].getName());
				echos("    DESCR: \t"+ opInfo[i].getDescription());
				echos("    PARAM: \t"+ opInfo[i].getSignature().length +" parameter(s)");
				echos("    DESCRIPTOR: \t" + (((ModelMBeanOperationInfo)opInfo[i]).getDescriptor()).toString());
			}
		} else echos(" ** No operations ** ");
		echos("\nNOTIFICATIONS");
		MBeanNotificationInfo[] notifInfo = info.getNotifications();
		if (notifInfo.length>0)
		{
			for (int i=0; i<notifInfo.length; i++)
			{
				echos(" ** NAME: \t"+ notifInfo[i].getName());
				echos("    DESCR: \t"+ notifInfo[i].getDescription());
				echos("    DESCRIPTOR: \t" + (((ModelMBeanNotificationInfo) notifInfo[i]).getDescriptor()).toString());
			}
		} else echos(" ** No notifications **");

	}

}
	
