package net.jnjmx.ch6;

import javax.management.Attribute;
import javax.management.AttributeList;
import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.Notification;
import javax.management.NotificationListener;
import javax.management.ObjectName;
import javax.management.monitor.MonitorNotification;
import net.jnjmx.ch6.ServiceMBean;

public class ServiceManager implements NotificationListener {

    public static void main(String[] args) throws Exception {
        MBeanServer mbs = MBeanServerFactory.createMBeanServer();
        ObjectName svc = new ObjectName("services:id=demo");
        mbs.createMBean("net.jnjmx.ch6.mbeans.Service", svc);
        String status = (String) mbs.getAttribute(svc, "Status");
        System.out.println(status);
        
        ObjectName svcmon = new ObjectName("monitors:id=service,mbean=demo");
        mbs.createMBean("javax.management.monitor.StringMonitor", svcmon);
        
        mbs.addNotificationListener(svcmon, new ServiceManager(), null, new Object());
        AttributeList smattrs = new AttributeList();
        smattrs.add(new Attribute("GranularityPeriod", new Long(100)));
        smattrs.add(new Attribute("ObservedAttribute", "Status"));
        smattrs.add(new Attribute("ObservedObject", svc));
        smattrs.add(new Attribute("NotifyMatch", new Boolean(true)));
        smattrs.add(new Attribute("StringToCompare", "stopped"));
        mbs.setAttributes(svcmon, smattrs);
        mbs.invoke(svcmon, "start", new Object[] {}, new String[] {});
        
        mbs.invoke(svc, "start", new Object[] {}, new String[] {});
        mbs.invoke(svc,"stop", new Object[] {}, new String[] {});
        mbs.invoke(svc,"start", new Object[] {}, new String[] {});
        mbs.invoke(svc,"pause", new Object[] {}, new String[] {});
        mbs.invoke(svc,"stop", new Object[] {}, new String[] {});
        
        mbs.invoke(svcmon, "stop", new Object[] {}, new String[] {});
    }
    
    public void handleNotification(Notification notification, Object handback) {
        if (notification.getType() == MonitorNotification.STRING_TO_COMPARE_VALUE_MATCHED) {
            MonitorNotification mn = (MonitorNotification) notification;
            System.out.println("ServiceMBean status = " + mn.getTrigger());
        }
    }
}
