package net.jnjmx.ch8;
/**
 * @author - Heather Kreger, Ward Harold
 * Java and JMX: Building Manageable Systems, Chapter 9
 * 
 * The program is provided "as is" without any warranty express or implied,
 * including the warranty of non-infringement and the implied warranties of
 * merchantibility and fitness for a particular purpose. The author will not be
 * liable for any damages suffered by you or any third party claim against 
 * you regarding the Program.
 */

import java.util.ArrayList;
import java.util.Random;

public class ProcessManager implements ProcessManagerMBean {
    ArrayList pids;

    public ProcessManager() {
        Random rng = new Random();
        pids = new ArrayList(16);
        for (int i = 0; i < 16;) {
            Integer pid = new Integer(rng.nextInt(9999));
            if (!pids.contains(pid)) {
                pids.add(pid);
                i++;
            }
        }
    }

    public int[] getPids() {
        int[] result = new int[pids.size()];
        for (int i = 0; i < result.length; i++) {
            result[i] = ((Integer) pids.get(i)).intValue();
        }
        return result;
    }

    public void kill(int pid) {
		pids.remove(new Integer(pid));
    }

}
