package net.jnjmx.ch9;

import java.io.Serializable;
import java.util.ArrayList;
import java.io.IOException;
import java.util.List;
import java.util.Map;

public interface Catalog  {

	public Map getCategories();

	public void classify(Item item, Category category);

	public Category createCategory(String name)
		throws CategoryExistsException;

	public Item createItem(String name, int price, int quantity)
		throws ItemExistsException;
	
	public void declassify(Item item, Category category);

	public void decreaseInventory(Item item, int amount)
		throws InventoryUnderflowException;

	public Category getCategory(String name);

	public void increaseInventory(Item item, int amount);

	public List getItems();

	public void removeCategory(Category category)
		throws NoSuchCategoryException;

	public void removeCategory(String name)
		throws NoSuchCategoryException;

	public void removeItem(Item item) throws NoSuchItemException;
	
	public void removeItem(int catalogno)
		throws NoSuchItemException;

}
