package net.jnjmx.ch9;
import java.io.IOException;

/**
 */
public class CatalogManager implements CatalogManagerMBean {
	// TackCatalogMBean Methods
	TackCatalogSS catalog;
	
	public CatalogManager (Catalog inCatalog) { 
		catalog = (TackCatalogSS)inCatalog;
	}

	public TackCatalogSS load(String name) 
		throws IOException, ClassNotFoundException{
		return (catalog.load(name));
	}
	
	public boolean isAutoCheckpointing() {
		return catalog.isAutoCheckpointing();
	}
	
	public synchronized void setAutoCheckpoint(boolean autoCheckpoint) {
		catalog.setAutoCheckpoint(autoCheckpoint);
	}

	public void doCheckpoint() {
		if (catalog.isAutoCheckpointing() == true) {
			catalog.doCheckpoint();
		}
	}
	
	public int getNumberOfItems() {
		return catalog.getStats("NumberOfItems");
	}
	
	public int getInventorySize() {
		return catalog.getStats("InventorySize");
	}
	
	public int getTotalSales() {
		return catalog.getStats("TotalSales");
	}
	
	public int getAccesses() {
		return catalog.getStats("Accesses");
	}

}
