#!/bin/ksh
# Script to run the RmiDaemon provided in the samples package.
# Sets the Classpath and uses the sample rmisample.policy file to grant 
# the necessary permissions


# Call the script to set your TMX4J_HOME directory
. ../../bin/solaris/set_tmx4j_home.sh

export ORIGINAL_CLASSPATH=$CLASSPATH

export CLASSPATH=$TMX4J_HOME/base/lib
export CLASSPATH=$CLASSPATH:$TMX4J_HOME/base/lib/jmxc.jar
export CLASSPATH=$CLASSPATH:$TMX4J_HOME/base/lib/jmxx.jar
export CLASSPATH=$CLASSPATH:$TMX4J_HOME/base/lib/log.jar
export CLASSPATH=$CLASSPATH:$TMX4J_HOME/ext/lib
export CLASSPATH=$CLASSPATH:$TMX4J_HOME/ext/lib/jmxext.jar
export CLASSPATH=$CLASSPATH:$TMX4J_HOME/ext

# Launch the rmiregistry in background (after having set the correct classpath)
echo Launching the rmiregistry ...
rmiregistry&

echo Warning: granting everyone all permissions to access the RMI daemon services.
echo .
echo Starting RMI daemon ...
java -cp $CLASSPATH -Djava.security.policy=$TMX4J_HOME/ext/samples/rmisample.policy samples.RmiDaemon

export CLASSPATH=$ORIGINAL_CLASSPATH

